// CustomButton.cpp : implementation file
//

#include "stdafx.h"
#include "server.h"
#include "CustomButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomButton

//#define  ODS_HOTLIGHT  0x0040



CCustomButton::CCustomButton()
{
	Font.CreateFont( 12, 0, 0, 0, FW_HEAVY, 0, 0, 0, ANSI_CHARSET, \
		OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, \
		VARIABLE_PITCH | FF_SWISS, "MS Sans Serif" );
}

CCustomButton::~CCustomButton()
{

}


BEGIN_MESSAGE_MAP(CCustomButton, CButton)
	//{{AFX_MSG_MAP(CCustomButton)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomButton message handlers


void CCustomButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{
	if (lpDrawItemStruct->CtlType==ODT_BUTTON )
	{
		CDC *pBtnDC = CDC::FromHandle(lpDrawItemStruct->hDC);	//ȡťDC
	//ȡťĻ滭
	CRect BtnRC = lpDrawItemStruct->rcItem;
	//ȡťĵǰ״̬
	int BtnState = lpDrawItemStruct->itemState;
	
	//ȡťı
	CString BtnText;
	GetWindowText(BtnText);

	CBrush		Brush;
	CBrush		*pOldBrush;
	CPoint		PT(2,2);
	
	pBtnDC->SelectObject(&Font);
	pBtnDC->SetTextColor( RGB( 255, 255, 250 ) );
	//ťýťѡ
	if (BtnState & ODS_SELECTED || BtnState & ODS_FOCUS)
	{
		Brush.CreateSolidBrush( RGB( 160, 160, 160 ) );
		pBtnDC->SetTextColor( RGB( 50, 50, 250 ) );
	}
	else
	{
		CBitmap bmp;
		bmp.LoadBitmap(IDB_BKBUTTON);
		Brush.CreatePatternBrush(&bmp); 
	}
	pOldBrush = pBtnDC->SelectObject( &Brush );
	pBtnDC->RoundRect(&BtnRC, PT);

	pBtnDC->SetBkMode(TRANSPARENT);
	pBtnDC->DrawText(BtnText, &BtnRC, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	pBtnDC->DeleteDC();	
	Brush.DeleteObject();
	}	
}


BOOL CCustomButton::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->hwnd==this->GetSafeHwnd()&&pMsg->message==WM_KEYDOWN && pMsg->wParam==13)
	{
		pMsg->lParam=0;
		pMsg->message=WM_LBUTTONDOWN;
	}
	if(pMsg->hwnd==this->GetSafeHwnd()&&pMsg->message==WM_KEYUP && pMsg->wParam==13)
	{
		pMsg->lParam=0;
		pMsg->message=WM_LBUTTONUP;
	}
	return CButton::PreTranslateMessage(pMsg);
}

